ON_ArcCurve Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_arccurve.h>`

Inheritance diagram for ON_ArcCurve:

## Public Member Functions

| ON_ArcCurve ()
| ON_ArcCurve (const ON_ArcCurve &)
virtual | ~ON_ArcCurve ()
unsigned int | SizeOf () const
ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
| ON_ArcCurve (const ON_Arc &arc)
| ON_ArcCurve (const ON_Arc &arc, double t0, double t1)
| ON_ArcCurve (const ON_Circle &circle)
| ON_ArcCurve (const ON_Circle &circle, double t0, double t1)
ON_ArcCurve & | operator= (const ON_ArcCurve &)
ON_ArcCurve & | operator= (const ON_Arc &arc)
ON_ArcCurve & | operator= (const ON_Circle &circle)
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
int | Dimension () const
ON_BOOL32 | GetBBox (double *, double *, ON_BOOL32=false) const
bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
ON_BOOL32 | Transform (const ON_Xform &)
ON_BOOL32 | SetDomain (double t0, double t1)
ON_Interval | Domain () const
bool | ChangeDimension (int desired_dimension)
ON_BOOL32 | ChangeClosedCurveSeam (double t)
int | SpanCount () const
ON_BOOL32 | GetSpanVector (double *) const
int | Degree () const
ON_BOOL32 | IsLinear (double=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsArc (const ON_Plane *=NULL, ON_Arc *=NULL, double=0.0) const
ON_BOOL32 | IsPlanar (ON_Plane *=NULL, double=0.0) const
ON_BOOL32 | IsInPlane (const ON_Plane &, double=0.0) const
ON_BOOL32 | IsClosed (void) const
ON_BOOL32 | IsPeriodic (void) const
bool | IsContinuous (ON::continuity c, double t, int *hint=NULL, double point_tolerance=ON_ZERO_TOLERANCE, double d1_tolerance=ON_ZERO_TOLERANCE, double d2_tolerance=ON_ZERO_TOLERANCE, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
ON_BOOL32 | Reverse ()
ON_BOOL32 | SetStartPoint (ON_3dPoint start_point)
ON_BOOL32 | SetEndPoint (ON_3dPoint end_point)
ON_BOOL32 | Evaluate (double, int, int, double *, int=0, int *=0) const
ON_BOOL32 | Trim (const ON_Interval &)
bool | Extend (const ON_Interval &domain)
virtual ON_BOOL32 | Split (double t, ON_Curve *&left_side, ON_Curve *&right_side) const
int | GetNurbForm (ON_NurbsCurve &, double=0.0, const ON_Interval *=NULL) const
int | HasNurbForm () const
ON_BOOL32 | GetCurveParameterFromNurbFormParameter (double, double *) const
ON_BOOL32 | GetNurbFormParameterFromCurveParameter (double, double *) const
bool | IsCircle () const
double | Radius () const
double | AngleRadians () const
double | AngleDegrees () const
Public Member Functions inherited from ON_Curve
void | DestroyRuntimeCache (bool bDelete=true)
| ON_Curve ()
| ON_Curve (const ON_Curve &)
ON_Curve & | operator= (const ON_Curve &)
virtual | ~ON_Curve ()
unsigned int | SizeOf () const
bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
virtual ON_Curve * | DuplicateCurve () const
ON::object_type | ObjectType () const
bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
ON_BOOL32 | GetDomain (double *t0, double *t1) const
bool | SetDomain (ON_Interval domain)
virtual ON_BOOL32 | GetSpanVectorIndex (double t, int side, int *span_vector_index, ON_Interval *span_domain) const
virtual ON_BOOL32 | GetParameterTolerance (double t, double *tminus, double *tplus) const
virtual int | IsPolyline (ON_SimpleArray< ON_3dPoint > *pline_points=NULL, ON_SimpleArray< double > *pline_t=NULL) const
bool | IsArcAt (double t, const ON_Plane *plane=0, ON_Arc *arc=0, double tolerance=ON_ZERO_TOLERANCE, double *t0=0, double *t1=0) const
virtual bool | IsEllipse (const ON_Plane *plane=NULL, ON_Ellipse *ellipse=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsClosable (double tolerance, double min_abs_size=0.0, double min_rel_size=10.0) const
virtual bool | GetNextDiscontinuity (ON::continuity c, double t0, double t1, double *t, int *hint=NULL, int *dtype=NULL, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
ON_3dPoint | PointAt (double t) const
ON_3dPoint | PointAtStart () const
ON_3dPoint | PointAtEnd () const
ON_3dVector | DerivativeAt (double t) const
ON_3dVector | TangentAt (double t) const
ON_3dVector | CurvatureAt (double t) const
ON_BOOL32 | FrameAt (double t, ON_Plane &plane) const
ON_BOOL32 | EvPoint (double t, ON_3dPoint &point, int side=0, int *hint=0) const
ON_BOOL32 | Ev1Der (double t, ON_3dPoint &point, ON_3dVector &first_derivative, int side=0, int *hint=0) const
ON_BOOL32 | Ev2Der (double t, ON_3dPoint &point, ON_3dVector &first_derivative, ON_3dVector &second_derivative, int side=0, int *hint=0) const
ON_BOOL32 | EvTangent (double t, ON_3dPoint &point, ON_3dVector &tangent, int side=0, int *hint=0) const
ON_BOOL32 | EvCurvature (double t, ON_3dPoint &point, ON_3dVector &tangent, ON_3dVector &kappa, int side=0, int *hint=0) const
bool | FirstSpanIsLinear (double min_length, double tolerance) const
bool | LastSpanIsLinear (double min_length, double tolerance) const
bool | FirstSpanIsLinear (double min_length, double tolerance, ON_Line *span_line) const
bool | LastSpanIsLinear (double min_length, double tolerance, ON_Line *span_line) const
ON_NurbsCurve * | NurbsCurve (ON_NurbsCurve *pNurbsCurve=NULL, double tolerance=0.0, const ON_Interval *subdomain=NULL) const
void | DestroyCurveTree ()
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual void | ClearBoundingBox ()
virtual bool | IsDeformable () const
virtual bool | MakeDeformable ()
virtual ON_BOOL32 | SwapCoordinates (int i, int j)
virtual ON_BOOL32 | HasBrepForm () const
virtual ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
virtual ON_COMPONENT_INDEX | ComponentIndex () const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)

## Public Attributes

ON_Arc | m_arc
ON_Interval | m_t
int | m_dim

## Additional Inherited Members

Protected Member Functions inherited from ON_Curve
bool | ParameterSearch (double t, int &index, bool bEnableSnap, const ON_SimpleArray< double > &m_t, double RelTol=ON_SQRT_EPSILON) const

## Detailed Description

Definition at line 35 of file opennurbs_arccurve.h.

## Constructor & Destructor Documentation

## ON_ArcCurve() [1/6]

ON_ArcCurve::ON_ArcCurve | ( |  | ) |

## ON_ArcCurve() [2/6]

ON_ArcCurve::ON_ArcCurve | ( | const ON_ArcCurve & |  | ) |

## ~ON_ArcCurve()

virtual ON_ArcCurve::~ON_ArcCurve | ( |  | ) |

virtual

## ON_ArcCurve() [3/6]

ON_ArcCurve::ON_ArcCurve | ( | const ON_Arc & | arc | ) |

## ON_ArcCurve() [4/6]

ON_ArcCurve::ON_ArcCurve | ( | const ON_Arc & | arc,
|  | double | t0,
|  | double | t1
| ) |  |

## ON_ArcCurve() [5/6]

ON_ArcCurve::ON_ArcCurve | ( | const ON_Circle & | circle | ) |

## ON_ArcCurve() [6/6]

ON_ArcCurve::ON_ArcCurve | ( | const ON_Circle & | circle,
|  | double | t0,
|  | double | t1
| ) |  |

## Member Function Documentation

## AngleDegrees()

double ON_ArcCurve::AngleDegrees | ( |  | ) | const

## AngleRadians()

double ON_ArcCurve::AngleRadians | ( |  | ) | const

## ChangeClosedCurveSeam()

ON_BOOL32 ON_ArcCurve::ChangeClosedCurveSeam | ( | double | t | ) |

virtual

Reimplemented from ON_Curve.

## ChangeDimension()

bool ON_ArcCurve::ChangeDimension | ( | int | desired_dimension | ) |

virtual

Reimplemented from ON_Curve.

## DataCRC()

ON__UINT32 ON_ArcCurve::DataCRC | ( | ON__UINT32 | current_remainder | ) | const

virtual

Reimplemented from ON_Object.

## Degree()

int ON_ArcCurve::Degree | ( |  | ) | const

virtual

Implements ON_Curve.

## Dimension()

int ON_ArcCurve::Dimension | ( |  | ) | const

virtual

Implements ON_Geometry.

## Domain()

ON_Interval ON_ArcCurve::Domain | ( |  | ) | const

virtual

Implements ON_Curve.

## Dump()

void ON_ArcCurve::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

## Evaluate()

ON_BOOL32 ON_ArcCurve::Evaluate | ( | double | ,
|  | int | ,
|  | int | ,
|  | double * | ,
|  | int | = `0`,
|  | int * | = `0`
| ) |  | const

virtual

Implements ON_Curve.

## Extend()

bool ON_ArcCurve::Extend | ( | const ON_Interval & | domain | ) |

virtual

Reimplemented from ON_Curve.

## GetBBox()

ON_BOOL32 ON_ArcCurve::GetBBox | ( | double * | ,
|  | double * | ,
|  | ON_BOOL32 | = `false`
| ) |  | const

virtual

Implements ON_Geometry.

## GetCurveParameterFromNurbFormParameter()

ON_BOOL32 ON_ArcCurve::GetCurveParameterFromNurbFormParameter | ( | double | ,
|  | double * |
| ) |  | const

virtual

Reimplemented from ON_Curve.

## GetNurbForm()

int ON_ArcCurve::GetNurbForm | ( | ON_NurbsCurve & | ,
|  | double | = `0.0`,
|  | const ON_Interval * | = `NULL`
| ) |  | const

virtual

Reimplemented from ON_Curve.

## GetNurbFormParameterFromCurveParameter()

ON_BOOL32 ON_ArcCurve::GetNurbFormParameterFromCurveParameter | ( | double | ,
|  | double * |
| ) |  | const

virtual

Reimplemented from ON_Curve.

## GetSpanVector()

ON_BOOL32 ON_ArcCurve::GetSpanVector | ( | double * |  | ) | const

virtual

Implements ON_Curve.

## GetTightBoundingBox()

bool ON_ArcCurve::GetTightBoundingBox | ( | ON_BoundingBox & | tight_bbox,
|  | int | bGrowBox = `false`,
|  | const ON_Xform * | xform = `0`
| ) |  | const

virtual

Reimplemented from ON_Geometry.

## HasNurbForm()

int ON_ArcCurve::HasNurbForm | ( |  | ) | const

virtual

Reimplemented from ON_Curve.

## IsArc()

ON_BOOL32 ON_ArcCurve::IsArc | ( | const ON_Plane * | = `NULL`,
|  | ON_Arc * | = `NULL`,
|  | double | = `0.0`
| ) |  | const

virtual

Reimplemented from ON_Curve.

## IsCircle()

bool ON_ArcCurve::IsCircle | ( |  | ) | const

## IsClosed()

ON_BOOL32 ON_ArcCurve::IsClosed | ( | void |  | ) | const

virtual

Reimplemented from ON_Curve.

## IsContinuous()

bool ON_ArcCurve::IsContinuous | ( | ON::continuity | c,
|  | double | t,
|  | int * | hint = `NULL`,
|  | double | point_tolerance = `ON_ZERO_TOLERANCE`,
|  | double | d1_tolerance = `ON_ZERO_TOLERANCE`,
|  | double | d2_tolerance = `ON_ZERO_TOLERANCE`,
|  | double | cos_angle_tolerance = `ON_DEFAULT_ANGLE_TOLERANCE_COSINE`,
|  | double | curvature_tolerance = `ON_SQRT_EPSILON`
| ) |  | const

virtual

Reimplemented from ON_Curve.

## IsInPlane()

ON_BOOL32 ON_ArcCurve::IsInPlane | ( | const ON_Plane & | ,
|  | double | = `0.0`
| ) |  | const

virtual

Implements ON_Curve.

## IsLinear()

ON_BOOL32 ON_ArcCurve::IsLinear | ( | double | = `ON_ZERO_TOLERANCE` | ) | const

virtual

Reimplemented from ON_Curve.

## IsPeriodic()

ON_BOOL32 ON_ArcCurve::IsPeriodic | ( | void |  | ) | const

virtual

Reimplemented from ON_Curve.

## IsPlanar()

ON_BOOL32 ON_ArcCurve::IsPlanar | ( | ON_Plane * | = `NULL`,
|  | double | = `0.0`
| ) |  | const

virtual

Reimplemented from ON_Curve.

## IsValid()

ON_BOOL32 ON_ArcCurve::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

## operator=() [1/3]

ON_ArcCurve& ON_ArcCurve::operator= | ( | const ON_Arc & | arc | ) |

## operator=() [2/3]

ON_ArcCurve& ON_ArcCurve::operator= | ( | const ON_ArcCurve & |  | ) |

## operator=() [3/3]

ON_ArcCurve& ON_ArcCurve::operator= | ( | const ON_Circle & | circle | ) |

## Radius()

double ON_ArcCurve::Radius | ( |  | ) | const

## Read()

ON_BOOL32 ON_ArcCurve::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_Object.

## Reverse()

ON_BOOL32 ON_ArcCurve::Reverse | ( |  | ) |

virtual

Implements ON_Curve.

## SetDomain()

ON_BOOL32 ON_ArcCurve::SetDomain | ( | double | t0,
|  | double | t1
| ) |  |

virtual

Reimplemented from ON_Curve.

## SetEndPoint()

ON_BOOL32 ON_ArcCurve::SetEndPoint | ( | ON_3dPoint | end_point | ) |

virtual

Reimplemented from ON_Curve.

## SetStartPoint()

ON_BOOL32 ON_ArcCurve::SetStartPoint | ( | ON_3dPoint | start_point | ) |

virtual

Reimplemented from ON_Curve.

## SizeOf()

unsigned int ON_ArcCurve::SizeOf | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## SpanCount()

int ON_ArcCurve::SpanCount | ( |  | ) | const

virtual

Implements ON_Curve.

## Split()

virtual ON_BOOL32 ON_ArcCurve::Split | ( | double | t,
|  | ON_Curve *& | left_side,
|  | ON_Curve *& | right_side
| ) |  | const

virtual

Reimplemented from ON_Curve.

## Transform()

ON_BOOL32 ON_ArcCurve::Transform | ( | const ON_Xform & |  | ) |

virtual

Reimplemented from ON_Geometry.

## Trim()

ON_BOOL32 ON_ArcCurve::Trim | ( | const ON_Interval & |  | ) |

virtual

Reimplemented from ON_Curve.

## Write()

ON_BOOL32 ON_ArcCurve::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_Object.

## Member Data Documentation

## m_arc

ON_Arc ON_ArcCurve::m_arc

Definition at line 412 of file opennurbs_arccurve.h.

## m_dim

int ON_ArcCurve::m_dim

Definition at line 420 of file opennurbs_arccurve.h.

## m_t

ON_Interval ON_ArcCurve::m_t

Definition at line 416 of file opennurbs_arccurve.h.

The documentation for this class was generated from the following file:

- pcl/surface/3rdparty/opennurbs/opennurbs_arccurve.h